#if !defined(__display_h)              // ԕB܂CN[hĂȂꍇɂ̂݁C̃t@Cgp
#define __display_h

/*  Project medit
    Project Team DoGA
    Copyright (c) 1995. All Rights Reserved.

    TuVXe:    medit.apx Application
    t@C:        display.h
    쐬:          Taka2


    Tv
    ====
    TWinDisplay (TWindow) p̃NX`
*/

#include <owl\owlpch.h>
#pragma hdrstop

#include <owl\window.h>

#include "meditapp.rh"            // ׂẴ\[X̒`
#include "matrix.h"
#include "anim.h"
const int MaxMarkers = 20;
class AnimationData;
class Bezier;
class Motion;
enum SelectType;


//{{TWindow = TWinDisplay}}
class TWinDisplay : public TWindow {

	AnimationData *anim;
	SelectType type;
	Matrix convmatrix;

	TPoint markerpoint[MaxMarkers];
	SelectType markertype[MaxMarkers];
	int markers;
public:
	TWinDisplay(TWindow* parent, AnimationData *a, SelectType sel, int x, int y, int w, int h);
	virtual ~TWinDisplay();

	void ShowCube(Matrix& m, int flag, SelectType t);
	void ShowCamera(Matrix& m, int flag);
	void ShowLight(Vector& vec, int flag);
	void DrawBezier(Bezier *bezier);

	void Redraw(void);
	void ShowMotion(TDC& dc, Motion *m);
	void ShowBezier(TDC& dc, Motion *m, int flag);
    void ShowMarker(TDC& dc, Motion *m);
    void ShowMesh(TDC& dc);

	Matrix GetMatrix(void);
	Matrix GetInvMatrix(void);

private:
	void Set4Marker(SelectType type, TPoint& pc, TPoint& p1, TPoint& p2);
	void Set5Marker(SelectType t1, SelectType t2, SelectType t3, TPoint& pc, TPoint& p1, TPoint& p2, TPoint& p3);
	void Set9Marker(SelectType t, TPoint& pc, TPoint& p1, TPoint& p2, TPoint& p3);
	void DrawMarker(TDC& dc);

	void OpCubeBegin(UINT modKeys, TPoint& point);
	void OpCubeDrag(UINT modKeys, TPoint& point, Vector& v);
	void OpCubeEnd(UINT modKeys, TPoint& point, Vector& v);

	void OpBezierBegin(UINT modKeys, TPoint& point);
	void OpBezierDrag(UINT modKeys, TPoint& point, Vector& v);
	void OpBezierEnd(UINT modKeys, TPoint& point, Vector& v);

	void OpZoomBegin(UINT modKeys, TPoint& point);

	void OpLightBegin(UINT modKeys, TPoint& point);
	void OpLightDrag(UINT modKeys, TPoint& point, Vector& v);
	void OpLightEnd(UINT modKeys, TPoint& point, Vector& v);

	void OpSelectMotion(UINT modKeys, TPoint& point, Vector& v);
	void OpSelectMotionAndDrag(UINT modKeys, TPoint& point, Vector& v);
	int GetPositionDistance(Motion *motion, TPoint &point);
	void DisplayCursorObject(UINT /*modKeys*/, TPoint& point);


//{{TWinDisplayVIRTUAL_BEGIN}}
public:
	virtual void Paint (TDC& dc, BOOL erase, TRect& rect);
//{{TWinDisplayVIRTUAL_END}}

//{{TWinDisplayRSP_TBL_BEGIN}}
protected:
	void EvLButtonDown (UINT modKeys, TPoint& point);
	void EvMouseMove (UINT modKeys, TPoint& point);
	void EvLButtonUp (UINT modKeys, TPoint& point);
	void EvRButtonDown (UINT modKeys, TPoint& point);
//{{TWinDisplayRSP_TBL_END}}
DECLARE_RESPONSE_TABLE(TWinDisplay);
};    //{{TWinDisplay}}

#endif                                      // __display_h ̔ԕ

